package springapp.common;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.aspectj.lang.JoinPoint;

public class LoggingAspect {

	protected final Log logger = LogFactory.getLog(getClass());

	public String beforeLogging(JoinPoint joinPoint) {
		String methodName = joinPoint.getSignature().getName();
		logger.info("calling: " + methodName);
		return methodName;
	}

	public void returningLogging(JoinPoint joinPoint, Object ret) {
		String methodName = joinPoint.getSignature().getName();
		logger.info("called successfully: " + methodName + " returns " + ret);
	}

	public void throwingLogging(JoinPoint joinPoint, Throwable ex) {
		String methodName = joinPoint.getSignature().getName();
		logger.info("exception occured: " + methodName + " throws "
					+ ex.getClass().getName());
	}

	public void afterLogging(JoinPoint joinPoint) {
		String methodName = joinPoint.getSignature().getName();
		logger.info("finish call: " + methodName);
	}
}
